/*************************************************************************************\


 #     #   #####   #     #   #####    #####   ######      #  #######  #####   ######
 #     #  #     #  ##    #  #     #  #     #  #     #    #      #    #     #  #     #
 #  #  #  #     #  # #   #  #              #  #     #   #       #          #  #     #
 #  #  #  #######  #  #  #  # #####   #####   #     #  #   #    #     #####   #     #
 #  #  #  #     #  #   # #  #     #        #  #     #  #######  #          #  #     #
 #  #  #  #     #  #    ##  #     #  #     #  #     #      #    #    #     #  #     #      
  ## ##   #     #  #     #   #####    #####   ######       #    #     #####   ######


                                  Preprocessor of
                 3D Wang Tiles with Ellipsoidal Inclusions for T3D
                           Copyright: Daniel Rypl 2018

\*************************************************************************************/

/* IMPORTANT: this file is included in wang3d4t3d.c and uses static global variables defined there !!! */

#define process_aa_side_geometry                   process_y_side_geometry
#define check_inclusion_outside_tile_aa_side       check_inclusion_outside_tile_y_side
#define get_aa_side_patch_id                       get_y_side_patch_id
#define aa_intersection                            y_intersection
#define aa_touching                                y_touching
#define output_bb_edge_vertex                      output_z_edge_vertex
#define output_cc_edge_vertex                      output_x_edge_vertex
#define output_bb_edge_curve                       output_z_edge_curve
#define output_cc_edge_curve                       output_x_edge_curve
#define halving_bb                                 halving_z
#define halving_cc                                 halving_x
#define aa_face_is                                 y_face_is
#define bb_edge_is                                 z_edge_is
#define cc_edge_is                                 x_edge_is
#define aa_ind                                     y_ind
#define bb_ind                                     z_ind
#define cc_ind                                     x_ind
#define ind_aa                                     ind_y
#define ind_bb                                     ind_z
#define ind_cc                                     ind_x
#define bbbb_ind                                   zz_ind
#define cccc_ind                                   xx_ind
#define shift_aa                                   shift_y
#define shift_bb                                   shift_z
#define shift_cc                                   shift_x
#define aa_patch_id                                y_patch_id
#define bb_count                                   z_count
#define cc_count                                   x_count
#define bb_curve_id                                z_curve_id
#define cc_curve_id                                x_curve_id
#define sign_bb                                    sign_z
#define sign_cc                                    sign_x
#define aa_side_vertex_array                       y_side_vertex_array
#define aa_side_vertices                           y_side_vertices
#define bb_edge_vertex_id_array                    z_edge_vertex_id_array
#define cc_edge_vertex_id_array                    x_edge_vertex_id_array
#define bb_edge_vertex_data_array                  z_edge_vertex_data_array
#define cc_edge_vertex_data_array                  x_edge_vertex_data_array
#define bb_edge_vertices                           z_edge_vertices
#define cc_edge_vertices                           x_edge_vertices
#define bb_edge_curve_1_array                      z_edge_curve_1_array
#define cc_edge_curve_1_array                      x_edge_curve_1_array
#define bb_edge_curves_1                           z_edge_curves_1
#define cc_edge_curves_1                           x_edge_curves_1
#define bb_edge_curves_2                           z_edge_curves_2
#define cc_edge_curves_2                           x_edge_curves_2
#define aa_side_patch_array                        y_side_patch_array
#define aa_side_patches                            y_side_patches 
#ifndef HALF_MAX_TILES
#define aa_side_patches_total                      y_side_patches_total
#endif
#define aa_side_curve_array                        y_side_curve_array
#define aa_side_curves                             y_side_curves
#define dir_aa                                     dir_y

#define aa                                         y
#define bb                                         z
#define cc                                         x

#define AA                                         Y
#define BB                                         Z
#define CC                                         X

#define AABB                                       YZ
#define AACC                                       YX

#ifdef DEBUG_PRINT
#define string_aa                                  "y"
#define string_bb                                  "z"
#define string_cc                                  "x"
#endif

#include "geom3d_xyz.c"

/* IMPORTANT: note thay geom3d_y.c is included in wang3d4t3d.c
	 it is therefore necessary to undef all above directives to prevent their application to code following the inclusion */

#undef process_aa_side_geometry
#undef check_inclusion_outside_tile_aa_side
#undef get_aa_side_patch_id
#undef aa_intersection
#undef aa_touching
#undef output_bb_edge_vertex
#undef output_cc_edge_vertex
#undef output_bb_edge_curve
#undef output_cc_edge_curve
#undef halving_bb
#undef halving_cc
#undef aa_face_is
#undef bb_edge_is
#undef cc_edge_is
#undef aa_ind
#undef bb_ind
#undef cc_ind
#undef ind_aa
#undef ind_bb
#undef ind_cc
#undef bbbb_ind
#undef cccc_ind
#undef shift_aa
#undef shift_bb
#undef shift_cc
#undef bb_count
#undef cc_count
#undef aa_patch_id
#undef bb_curve_id
#undef cc_curve_id
#undef sign_bb
#undef sign_cc
#undef aa_side_vertex_array
#undef aa_side_vertices
#undef bb_edge_vertex_id_array
#undef cc_edge_vertex_id_array
#undef bb_edge_vertex_data_array
#undef cc_edge_vertex_data_array
#undef bb_edge_vertices
#undef cc_edge_vertices
#undef bb_edge_curve_1_array
#undef cc_edge_curve_1_array
#undef bb_edge_curves_1
#undef cc_edge_curves_1
#undef bb_edge_curves_2
#undef cc_edge_curves_2
#undef aa_side_patch_array
#undef aa_side_patches
#ifndef HALF_MAX_TILES
#undef aa_side_patches_total
#endif
#undef aa_side_curve_array
#undef aa_side_curves
#undef dir_aa

#undef aa
#undef bb
#undef cc

#undef AA
#undef BB
#undef CC

#undef AABB
#undef AACC

#ifdef DEBUG_PRINT
#undef string_aa
#undef string_bb
#undef string_cc
#endif
